<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RevRecScheduleRecurrenceList StructType
 * @subpackage Structs
 */
class RevRecScheduleRecurrenceList extends AbstractStructBase
{
    /**
     * The revRecScheduleRecurrence
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RevRecScheduleRecurrence[]
     */
    public $revRecScheduleRecurrence;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for RevRecScheduleRecurrenceList
     * @uses RevRecScheduleRecurrenceList::setRevRecScheduleRecurrence()
     * @uses RevRecScheduleRecurrenceList::setReplaceAll()
     * @param \StructType\RevRecScheduleRecurrence[] $revRecScheduleRecurrence
     * @param bool $replaceAll
     */
    public function __construct(array $revRecScheduleRecurrence = array(), $replaceAll = true)
    {
        $this
            ->setRevRecScheduleRecurrence($revRecScheduleRecurrence)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get revRecScheduleRecurrence value
     * @return \StructType\RevRecScheduleRecurrence[]|null
     */
    public function getRevRecScheduleRecurrence()
    {
        return $this->revRecScheduleRecurrence;
    }
    /**
     * This method is responsible for validating the values passed to the setRevRecScheduleRecurrence method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRevRecScheduleRecurrence method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRevRecScheduleRecurrenceForArrayConstraintsFromSetRevRecScheduleRecurrence(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem) {
            // validation for constraint: itemType
            if (!$revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem instanceof \StructType\RevRecScheduleRecurrence) {
                $invalidValues[] = is_object($revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem) ? get_class($revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem) : sprintf('%s(%s)', gettype($revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem), var_export($revRecScheduleRecurrenceListRevRecScheduleRecurrenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The revRecScheduleRecurrence property can only contain items of type \StructType\RevRecScheduleRecurrence, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set revRecScheduleRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\RevRecScheduleRecurrence[] $revRecScheduleRecurrence
     * @return \StructType\RevRecScheduleRecurrenceList
     */
    public function setRevRecScheduleRecurrence(array $revRecScheduleRecurrence = array())
    {
        // validation for constraint: array
        if ('' !== ($revRecScheduleRecurrenceArrayErrorMessage = self::validateRevRecScheduleRecurrenceForArrayConstraintsFromSetRevRecScheduleRecurrence($revRecScheduleRecurrence))) {
            throw new \InvalidArgumentException($revRecScheduleRecurrenceArrayErrorMessage, __LINE__);
        }
        $this->revRecScheduleRecurrence = $revRecScheduleRecurrence;
        return $this;
    }
    /**
     * Add item to revRecScheduleRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\RevRecScheduleRecurrence $item
     * @return \StructType\RevRecScheduleRecurrenceList
     */
    public function addToRevRecScheduleRecurrence(\StructType\RevRecScheduleRecurrence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RevRecScheduleRecurrence) {
            throw new \InvalidArgumentException(sprintf('The revRecScheduleRecurrence property can only contain items of type \StructType\RevRecScheduleRecurrence, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->revRecScheduleRecurrence[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\RevRecScheduleRecurrenceList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
